<?php
if (!defined('_CAN_LOAD_FILES_'))
	exit;
class AddThisGooglePlus extends Module{
	
	private $tbl_styles = array(
		0 => "No style",
		1 => "Style 1",
		2 => "Style 2",
		3 => "Style 3",
		4 => "Style 4",
		5 => "Style 5",
		6 => "Style 6",
		7 => "Style 7",
		8 => "Style 8",
		9 => "Style 9",
		10 => "Style 10",
		11 => "Style 11",
		12 => "Style 12",
		13 => "Style 13"
	);
	
	public function __construct(){
		$this->name = 'addthisgoogleplus';
		$this->tab = 'add_this_google_plus';
		$this->version = '1.0';
		$this->author = 'MICHAEL D.';
		parent::__construct();
		$this->displayName = $this->l('AddThis Google+');
		$this->description = $this->l('Add an addThis block with google+');
  		$this->confirmUninstall = $this->l('Are you sure you want to delete your details ?');
	}
	public function install(){
		if (
			!parent::install() OR
			!$this->registerHook('top') OR
			!$this->registerHook('footer') OR
			!$this->registerHook('productfooter') OR
			!$this->registerHook('leftcolumn') OR
			!$this->registerHook('centercolumn') OR
			!$this->registerHook('rightcolumn') OR
			// Temporary hooks. Do NOT hook any module on it. Some CRUD hook will replace them as soon as possible.
			!$this->registerHook('categoryAddition') OR
			!$this->registerHook('categoryUpdate') OR
			!$this->registerHook('categoryDeletion') OR
			!$this->registerHook('afterSaveAdminMeta') OR
			!Configuration::updateValue('ADDTHIS_GOOGLE_TOP', 0) OR 
			!Configuration::updateValue('ADDTHIS_GOOGLE_FOOTER', 0) OR 
			!Configuration::updateValue('ADDTHIS_GOOGLE_PRODUCTFOOTER', 0) OR 
			!Configuration::updateValue('ADDTHIS_GOOGLE_LEFTCOLUMN', 0) OR 
			!Configuration::updateValue('ADDTHIS_GOOGLE_CENTERCOLUMN', 0) OR 
			!Configuration::updateValue('ADDTHIS_GOOGLE_RIGHTCOLUMN', 0)
		){
			return false;
		}
		return true;
	}
	public function uninstall(){
		if (
			!parent::uninstall() OR
			!Configuration::deleteByName('ADDTHIS_GOOGLE_TOP') OR
			!Configuration::deleteByName('ADDTHIS_GOOGLE_FOOTER') OR
			!Configuration::deleteByName('ADDTHIS_GOOGLE_PRODUCTFOOTER') OR
			!Configuration::deleteByName('ADDTHIS_GOOGLE_LEFTCOLUMN') OR
			!Configuration::deleteByName('ADDTHIS_GOOGLE_CENTERCOLUMN') OR
			!Configuration::deleteByName('ADDTHIS_GOOGLE_RIGHTCOLUMN')
		){
			return false;
		}
		return true;
	}
	
	public function getContent(){
		$output = '<h2>'.$this->displayName.'</h2>';
		if (Tools::isSubmit('submitBlockAddThis')){
			// recup infos formulaire
			$formStyleChooseHookTop				= Tools::getValue('formStyleChooseHookTop');
			$formStyleChooseHookFooter			= Tools::getValue('formStyleChooseHookFooter');
			$formStyleChooseHookProductFooter	= Tools::getValue('formStyleChooseHookProductFooter');
			$formStyleChooseHookLeftColumn		= Tools::getValue('formStyleChooseHookLeftColumn');
			$formStyleChooseHookCenterColumn	= Tools::getValue('formStyleChooseHookCenterColumn');
			$formStyleChooseHookRightColumn		= Tools::getValue('formStyleChooseHookRightColumn');
				
			// verif
			if(
				$formStyleChooseHookTop < 0				||
				$formStyleChooseHookFooter < 0			||
				$formStyleChooseHookProductFooter < 0	||
				$formStyleChooseHookLeftColumn < 0		||
				$formStyleChooseHookCenterColumn < 0	||
				$formStyleChooseHookRightColumn < 0
			){
				//$output .= '<div class="alert error">'.$this->l('Maximum depth: Invalid number.').'</div>';
				$output .= $this->displayError($this->l('Style not positive'));
				
			}else{
				Configuration::updateValue('ADDTHIS_GOOGLE_TOP', (int)($formStyleChooseHookTop));
				Configuration::updateValue('ADDTHIS_GOOGLE_FOOTER', (int)($formStyleChooseHookFooter));
				Configuration::updateValue('ADDTHIS_GOOGLE_PRODUCTFOOTER', (int)($formStyleChooseHookProductFooter));
				Configuration::updateValue('ADDTHIS_GOOGLE_LEFTCOLUMN', (int)($formStyleChooseHookLeftColumn));
				Configuration::updateValue('ADDTHIS_GOOGLE_CENTERCOLUMN', (int)($formStyleChooseHookCenterColumn));
				Configuration::updateValue('ADDTHIS_GOOGLE_RIGHTCOLUMN', (int)($formStyleChooseHookRightColumn));
				
				$this->_clearAddthisCache();
				
				$output .= $this->displayConfirmation($this->l('Settings updated...'));
			}
		}
		return $output.$this->displayForm();
	}
	
	/**
	 * 
	 * Formulaire
	 */
	public function displayForm(){
		$liste = '
		<fieldset>
			<legend><img src="'.$this->_path.'logo.gif" alt="" title="" />'.$this->l('Style').'</legend>';
			foreach( $this->tbl_styles as $k => $v ){
				if( $k != 0 ){
					$liste .= 'Style '.$k.' <img src="'.$this->_path.'images/style'.$k.'.png" alt="style '.$k.'" title="style '.$k.'" /><br />';
				}
			}
		$liste .= '
		</fieldset>';
		
		$form = '
		<form action="'.$_SERVER['REQUEST_URI'].'" method="post">
			<fieldset>
				<legend><img src="'.$this->_path.'logo.gif" alt="" title="" />'.$this->l('Settings').'</legend>
				
				<label>'.$this->l('Style choose for zone top').'</label>
				<div class="margin-form">
					<select name="formStyleChooseHookTop">';
						foreach( $this->tbl_styles as $k=>$v ){
							if( Configuration::get('ADDTHIS_GOOGLE_TOP') == $k ){
								$selected = "selected";
							}else{
								$selected = "";
							}
							
							$form .= '
							<option value="'.$k.'" '.$selected.'>'.$this->l($v).'</option>';
						}
					$form .= '
					</select>
					<p class="clear">'.$this->l('Choose the style for this zone (0 = no style)').'</p>
				</div>
				
				<label>'.$this->l('Style choose for zone footer').'</label>
				<div class="margin-form">
					<select name="formStyleChooseHookFooter">';
						foreach( $this->tbl_styles as $k=>$v ){
							if( Configuration::get('ADDTHIS_GOOGLE_FOOTER') == $k ){
								$selected = "selected";
							}else{
								$selected = "";
							}
							
							$form .= '
							<option value="'.$k.'" '.$selected.'>'.$this->l($v).'</option>';
						}
					$form .= '
					</select>
					<p class="clear">'.$this->l('Choose the style for this zone (0 = no style)').'</p>
				</div>
				
				<label>'.$this->l('Style choose for zone product footer').'</label>
				<div class="margin-form">
					<select name="formStyleChooseHookProductFooter">';
						foreach( $this->tbl_styles as $k=>$v ){
							if( Configuration::get('ADDTHIS_GOOGLE_PRODUCTFOOTER') == $k ){
								$selected = "selected";
							}else{
								$selected = "";
							}
							
							$form .= '
							<option value="'.$k.'" '.$selected.'>'.$this->l($v).'</option>';
						}
					$form .= '
					</select>
					<p class="clear">'.$this->l('Choose the style for this zone (0 = no style)').'</p>
				</div>
				
				
				
				
				<label>'.$this->l('Style choose for zone left column').'</label>
				<div class="margin-form">
					<select name="formStyleChooseHookLeftColumn">';
						foreach( $this->tbl_styles as $k=>$v ){
							if( Configuration::get('ADDTHIS_GOOGLE_LEFTCOLUMN') == $k ){
								$selected = "selected";
							}else{
								$selected = "";
							}
							
							$form .= '
							<option value="'.$k.'" '.$selected.'>'.$this->l($v).'</option>';
						}
					$form .= '
					</select>
					<p class="clear">'.$this->l('Choose the style for this zone (0 = no style)').'</p>
				</div>
				
				<label>'.$this->l('Style choose for zone center column').'</label>
				<div class="margin-form">
					<select name="formStyleChooseHookCenterColumn">';
						foreach( $this->tbl_styles as $k=>$v ){
							if( Configuration::get('ADDTHIS_GOOGLE_CENTERCOLUMN') == $k ){
								$selected = "selected";
							}else{
								$selected = "";
							}
							
							$form .= '
							<option value="'.$k.'" '.$selected.'>'.$this->l($v).'</option>';
						}
					$form .= '
					</select>
					<p class="clear">'.$this->l('Choose the style for this zone (0 = no style)').'</p>
				</div>
				
				<label>'.$this->l('Style choose for zone right column').'</label>
				<div class="margin-form">
					<select name="formStyleChooseHookRightColumn">';
						foreach( $this->tbl_styles as $k=>$v ){
							if( Configuration::get('ADDTHIS_GOOGLE_RIGHTCOLUMN') == $k ){
								$selected = "selected";
							}else{
								$selected = "";
							}
							
							$form .= '
							<option value="'.$k.'" '.$selected.'>'.$this->l($v).'</option>';
						}
					$form .= '
					</select>
					<p class="clear">'.$this->l('Choose the style for this zone (0 = no style)').'</p>
				</div>
				
				<center><input type="submit" name="submitBlockAddThis" value="'.$this->l('Save').'" class="button" /></center>
			</fieldset>
		</form>';
		
		return $liste.$form;
	}
	
	/**
	*
	* retourne le style addthis a afficher
	* @param int $style
	*/
	public function getTypeAddthis( $style ){
		switch ($style){
			// Std
			case 1 :
				$s = '
				<div class="addthis_toolbox addthis_default_style">
				     <a class="addthis_button_google_plusone"></a> 
				</div>';
				break;
	
			// Larger Standard
			case 2 :
				$s = '
				<div class="addthis_toolbox addthis_default_style">
					<a class="addthis_button_google_plusone" g:plusone:size="medium"></a>
				</div>';
				break;
	
			// Vertical Counter
			case 3 :
				$s ='
				<div class="addthis_toolbox addthis_default_style">
					<a class="addthis_button_google_plusone" g:plusone:size="tall"></a> 
				</div>';
				break;
	
			// Standard with No Count
			case 4 :
				$s ='
				<div class="addthis_toolbox addthis_default_style">
					<a class="addthis_button_google_plusone" g:plusone:count="false"></a>
				</div>';
				break;
	
			// Bubble
			case 5 :
				$s ='
				<div class="addthis_toolbox addthis_default_style">
					<a class="addthis_button_google_plusone" g:plusone:annotation="bubble"></a> 
				</div>';
				break;
	
			// Inline
			case 6 :
				$s ='
				<div class="addthis_toolbox addthis_default_style">
					<a class="addthis_button_google_plusone" g:plusone:annotation="inline"></a>
				</div>';
				break;
	
			// None
			case 7 :
				$s ='
				<div class="addthis_toolbox addthis_default_style">
					<a class="addthis_button_google_plusone" g:plusone:annotation="none"></a>
				</div>';
				break;
	
			// Google+ Badge
			case 8 :
				$s = '
				<div class="addthis_toolbox addthis_default_style">
				     <a class="addthis_button_google_plusone_badge" g:plusone:href="https://plus.google.com/102383601500147943541/"></a>
				</div>';
				break;
				
			// Badge
			case 9 :
				$s = '
				<div class="addthis_toolbox addthis_default_style">
					<a class="addthis_button_google_plusone_badge" g:plusone:size="badge" g:plusone:href="https://plus.google.com/102383601500147943541/"></a>
				</div>';
				break;
				
			// Small Badge
			case 10 :
				$s = '
				<div class="addthis_toolbox addthis_default_style">
					<a class="addthis_button_google_plusone_badge" g:plusone:size="smallbadge" g:plusone:href="https://plus.google.com/102383601500147943541/"></a>
				</div>';
				break;
				
			// Large
			case 11 :
				$s = '
				<div class="addthis_toolbox addthis_default_style">
					<a class="addthis_button_google_plusone_badge" g:plusone:size="large" g:plusone:name="AddThis" g:plusone:href="https://plus.google.com/102383601500147943541/"></a> 
				</div>';
				break;
				
			// Medium
			case 12 :
				$s = '
				<div class="addthis_toolbox addthis_default_style">
					<a class="addthis_button_google_plusone_badge" g:plusone:size="medium" g:plusone:name="AddThis" g:plusone:href="https://plus.google.com/102383601500147943541/"></a> 
				</div>';
				break;
				
			// Small
			case 13 :
				$s = '
				<div class="addthis_toolbox addthis_default_style">
					<a class="addthis_button_google_plusone_badge" g:plusone:size="small" g:plusone:name="AddThis" g:plusone:href="https://plus.google.com/102383601500147943541/"></a> 
				</div>';
				break;
				
			// HORIZONTAL
			default :
				$s ='';
		}
		return "<!-- AddThis Button Google+ BEGIN -->".$s."<!-- AddThis Button Google+ END -->";
	}
	
	/**
	 * 
	 * hook top
	 * @param array $params
	 */
	public function hookTop($params){
		global $smarty, $cookie;
		//echo "Cookie: ".$cookie->__get('typesite');
		
		$id_customer = (int)($params['cookie']->id_customer);
		// Get all groups for this customer and concatenate them as a string: "1,2,3..."
		// It is necessary to keep the group query separate from the main select query because it is used for the cache
		$groups = $id_customer ? implode(', ', Customer::getGroupsStatic($id_customer)) : _PS_DEFAULT_CUSTOMER_GROUP_;
		$id_product = (int)(Tools::getValue('id_product', 0));
		$id_category = (int)(Tools::getValue('id_category', 0));
		$id_lang = (int)($params['cookie']->id_lang);
		$smartyCacheId = 'addthisgoogleplus|'.$groups.'_'.$id_lang.'_'.$id_product.'_'.$id_category;
		Tools::enableCache();
		if (!$this->isCached('addthis-top.tpl', $smartyCacheId)){
			// traitement ici
			//if (Tools::isSubmit('submitBlockAddThis')){}
		}
		$smarty->cache_lifetime = 31536000; // 1 Year

		$style = $this->getTypeAddthis( Configuration::get('ADDTHIS_GOOGLE_TOP') );
		$smarty->assign('addthis_google_top', $style);
		$display = $this->display(__FILE__, 'addthis-top.tpl', $smartyCacheId);
		Tools::restoreCacheSettings();
		return $display;
	}
	
	/**
	 * 
	 * hook footer
	 * @param array $params
	 */
	public function hookFooter($params){
		global $smarty, $cookie;
		
		$style = $this->getTypeAddthis( Configuration::get('ADDTHIS_GOOGLE_FOOTER') );
		$smarty->assign('addthis_google_footer', $style);
		$display = $this->display(__FILE__, 'addthis-footer.tpl');
		return $display;
	}
	
	/**
	 * 
	 * hook product footer
	 * @param array $params
	 */
	public function hookProductFooter($params){
		global $smarty, $cookie;

		$style = $this->getTypeAddthis( Configuration::get('ADDTHIS_GOOGLE_PRODUCTFOOTER') );
		$smarty->assign('addthis_google_productfooter', $style);
		$display = $this->display(__FILE__, 'addthis-productfooter.tpl');
		return $display;
	}

	
	/**
	 *
	 * hook left column
	 * @param array $params
	 */
	public function hookLeftColumn($params){
		global $smarty, $cookie;
		
		$style = $this->getTypeAddthis( Configuration::get('ADDTHIS_GOOGLE_LEFTCOLUMN') );
		$smarty->assign('addthis_google_leftcolumn', $style);
		$display = $this->display(__FILE__, 'addthis-leftcolumn.tpl');
		return $display;
	}
	
	/**
	 *
	 * hook center column
	 * @param array $params
	 */
	public function hookCenterColumn($params){
		global $smarty, $cookie;
		
		$style = $this->getTypeAddthis( Configuration::get('ADDTHIS_GOOGLE_CENTERCOLUMN') );
		$smarty->assign('addthis_google_centercolumn', $style);
		$display = $this->display(__FILE__, 'addthis-centercolumn.tpl');
		return $display;
	}
	
	/**
	*
	* hook right column
	* @param array $params
	*/
	public function hookRightColumn($params){
		global $smarty, $cookie;
	
		$style = $this->getTypeAddthis( Configuration::get('ADDTHIS_GOOGLE_RIGHTCOLUMN') );
		$smarty->assign('addthis_google_rightcolumn', $style);
		$display = $this->display(__FILE__, 'addthis-rightcolumn.tpl');
		return $display;
	}
	
	/**
	 * 
	 * vider le cache
	 */
	private function _clearAddthisCache(){
		$this->_clearCache('addthisgoogleplus.tpl');
		Tools::restoreCacheSettings();
	}
	public function hookCategoryAddition($params){
		$this->_clearAddthisCache();
	}
	public function hookCategoryUpdate($params){
		$this->_clearAddthisCache();
	}
	public function hookCategoryDeletion($params){
		$this->_clearAddthisCache();
	}
	public function hookAfterSaveAdminMeta($params){
		$this->_clearAddthisCache();
	}
}